// pbinfo = putere1
#include <iostream>

using ull = unsigned long long;

using namespace std;

ull ExpBin(ull b, ull n, ull mod)
{
    ull res = 1, x = b;
    while(n)
    {
        if (n % 2 == 1) 
			res = (res * x) % mod;
        x = (x * x) % mod;
        n /= 2;
    }
    return res;
}

// n = 1  1   0   1  = 2^3 + 2^2 + 2^0

/*                        1        1         0        1 
 * x^(2^3 + 2^2 + 1) = x^(2^3) * x^(2^2) * x^(2^1) * x^(1)  
 *                   =   x^8   * x^4    *  x^2     * x^1
 *                                                     p      
 *                                                          
 * 
 */  


int main()
{
    ull b, n, p, mod = 1, rez;

    cin >> b >> n >> p;

    for (ull i = 1; i <= p; i++)
        mod *= 10;
    // aici mod = 10^p
    
    rez = ExpBin(b, n, mod); // O(log(n))
    cout << rez;
    return 0;
}
